extern void QuickInitUI(int bDoSplash);
extern void StartUI();
extern void ShutdownUI();

extern int GetInputChar();
extern int GetExtCommand();

void dzzGetInputString(int nWhichMemory, const char *pszQuestion, char *pszBuf, int nMaxLen, int bCancelable, char *pszInvalid);

extern int dzzPopMC(const char *pszTitle, int nSelections, int nDefault,
    const char **ppszLabels, const char ***pppszTexts);
extern int dzzGetMCResult();

extern void dzzPopYN(const char *szQuestion);
extern char dzzGetYNResult();
extern int dzzIsYNPopped();

extern void SetMapCursor(int nX, int nY);

extern void dzzPopRL(const char *szQuestion);
extern char dzzGetRLResult();
extern int dzzIsRLPopped();

extern void dzzPopYNQ(const char *szQuestion);
extern char dzzGetYNQResult();
extern int dzzIsYNQPopped();

extern void SetStatusCursor(int nX, int nY);
extern void StatusPutstr(char *pStr, int attr);

extern int NewTextWindow();
extern void AppendTextToTextWindow(int nID, char *pszText, int attr);
extern void DisplayTextWindow(int nID);
extern void FreeTextWindow(int nID);
extern void HideTextWindow(int nID);
extern void WaitForTextWindowKey();
extern int WaitForMenu(int nID);

extern void StartMenu(int nID);
extern void AddMenuItem(int nID, int nGlyph, const ANY_P *pData,
    const char *pStr, int bBold, int bPreselect);
extern int SelectMenu(int nID, int nFlags, int bShowSelectAll, int bShowGold, int bShowFingers, unsigned long **ppSel);

void dzzSetStatusLines(char *, char *);

extern void ClearWindow(int nID);

extern void AddTopTextLine(char *pStr);
extern void AppendTopTextLine(char *pStr);
extern void ScrollUpTopTextLines();
extern void ScrollDownTopTextLines();

extern void StartTrackingDirection();
extern char GetTrackedDirection();
extern int IsTrackingDirection();

extern void SetMapCenter(int nX, int nY);
void ClearMaps();
void SetMapGlyph(int nX, int nY, int nGlyph, int ch, int nColor);

#define GP2X_START     (1<<8)
#define GP2X_SELECT    (1<<9)
#define GP2X_L         (1<<10)
#define GP2X_R         (1<<11)
#define GP2X_A         (1<<12)
#define GP2X_B         (1<<13)
#define GP2X_X         (1<<14)
#define GP2X_Y         (1<<15)
#define GP2X_VOL_UP    (1<<23)
#define GP2X_VOL_DOWN  (1<<22)
#define GP2X_PUSH      (1<<27)

#define JOYDIR_NONE    0
#define JOYDIR_U       1
#define JOYDIR_UUL     2
#define JOYDIR_UL      3
#define JOYDIR_LUL     4
#define JOYDIR_L       5
#define JOYDIR_LDL     6
#define JOYDIR_DL      7
#define JOYDIR_DDL     8
#define JOYDIR_D       9
#define JOYDIR_DDR     10
#define JOYDIR_DR      11
#define JOYDIR_RDR     12
#define JOYDIR_R       13
#define JOYDIR_RUR     14
#define JOYDIR_UR      15
#define JOYDIR_UUR     16

#define XRGB(r,g,b) (((r) << 11) | ((g) << 5) | b)
